#!/bin/sh
#
# Any other command-line args are passed along to Jalview

#Assume that the path to Jalview is the same as the path to this script
PATH_TO_ME=`which $0`;
   
#Remove the name of this script from the end of the path
PATH_TO_ME=`echo $PATH_TO_ME | sed -e "s/\(.*\)\/.*/\1/g"`

JALVIEW_ROOT=$PATH_TO_ME

if [ -z "${JALVIEW_ROOT}" ]; then
    echo Warning: JALVIEW_ROOT not set and could not guess what it should be.
    exit 1
else
    echo JALVIEW_ROOT set to ${JALVIEW_ROOT}
fi

CLASSES_OR_JAR=${JALVIEW_ROOT}/jalview.jar

# set the javapath to the path given by 'which java', without the bin/java
# (basically, get the path to java and trim off the last 9 characters;
#  obviously, this approach won't work if you've installed java strangely,
#  but java probably won't work either)
JAVAPATH=`which java | awk ' { print (substr($0,0, length($0) - 9)) } '`;

echo Using version of Java in ${JAVAPATH}: ${JAVAPATH}/bin/java

#make sure that java is actually there

if [ ! -s ${JAVAPATH}/bin/java ]; then
    #if it isn't, fail
    echo Could not make a good guess about the location of Java
    exit 1
fi


${JAVAPATH}/bin/java \
    -classpath ${CLASSES_OR_JAR} \
    jalview.AlignFrame "$@"
exit $?;

