package jalview;

public class BackTranslate {
  public static void main(String[] args) {
    try {
      FastaFile fa = new FastaFile(args[0],"File");
      Sequence seq1 = (Sequence)fa.seqs.elementAt(0);
      String st = SequenceProperties.backTranslate(seq1.sequence);
      int ran = (int)(Math.random()*st.length());
      String st2 = st.substring(0,ran) + "G" + st.substring(ran);
      String prot = SequenceProperties.translate(st2);
      Sequence seq2 = new Sequence("seq2",prot,0,0);
      System.out.println(seq1.sequence);
      System.out.println(seq2.sequence);
      seq1.sequence = SequenceProperties.fullBackTranslate(seq1.sequence);
      System.out.println(seq1.sequence);
      seq2.sequence = SequenceProperties.fullBackTranslate(seq2.sequence);
      System.out.println(seq2.sequence);
      FSAlign as = new FSAlign(seq1,seq2,"dna");
      System.out.println(as);
      as.gapExtend = 50;
      as.gapOpen  = 100;
      as.calcScoreMatrix();
      as.traceAlignment();
      as.printAlignment();

    } catch (Exception e) {
      System.out.println(e);
    }
  }
}
