/* Jalview - a java multiple alignment editor
 * Copyright (C) 1998  Michele Clamp
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jalview;
import java.awt.*;



public class IdCanvas extends Canvas {
  Image img;
  Graphics gg;

  int imgWidth;
  int imgHeight;

  Font f;
  
  int charWidth;
  int charHeight;
  
  int idWidth = 120;

  protected IdPanel idPanel;

  boolean paintFlag = false;
  boolean showScores = true;
		boolean wrap       = false;

  DrawableAlignment da;

  int starty;
  int endy;

  public IdCanvas(IdPanel idPanel) {
    System.out.println("here");
    this.idPanel = idPanel;
    System.out.println("here");
  }
  public boolean keyDown(Event evt, int key) {
    requestFocus();
    return false;
  }
  public void paint(Graphics g) {
    if (img == null || imgWidth != size().width || imgHeight != size().height || paintFlag == true) {
      da = idPanel.alignPanel.seqPanel.align;
      imgWidth = size().width;
      idWidth = size().width;
      
      FontMetrics fm = g.getFontMetrics(idPanel.alignPanel.seqPanel.seqCanvas.f);

      idWidth = idPanel.alignPanel.seqPanel.align.maxIdLength(fm)+2;
      imgHeight = size().height;

      if (imgWidth < 0 ) {imgWidth = 700;}
      if (imgHeight < 0 ) {imgHeight = 500;}

      img = createImage(imgWidth,imgHeight);

      gg = img.getGraphics();
      gg.setColor(Color.white);
      gg.fillRect(0,0,imgWidth,imgHeight);

      //Now the fonty bit
      f = idPanel.alignPanel.seqPanel.seqCanvas.f;

      gg.setFont(f);
      fm = gg.getFontMetrics(f);
      charWidth = fm.charWidth('W');
      charHeight = setCharHeight(fm,showScores);

      paintFlag = false;

    }
    //Fill in the background
    gg.setColor(Color.white);
    gg.fillRect(0,0,imgWidth,imgHeight);
    gg.setColor(Color.black);

    //Which ids are we printing
    starty = idPanel.alignPanel.seqPanel.offy;
    endy = getEndy();
    
    if (starty < 0) {
	starty = 0;
    }
    
    
    
    if (wrap) {
	starty = idPanel.alignPanel.seqPanel.offy%idPanel.alignPanel.seqPanel.seqCanvas.chunkheight;
	int ypos = 0;

	int rowstart = starty;

	if (starty == 0) {
	    ypos = 2*charHeight;
	} else if (starty == 1) {
	    starty = 0;
	    ypos = charHeight;
	}

	endy   = starty + idPanel.alignPanel.seqPanel.align.size();
	
	if (endy > idPanel.alignPanel.seqPanel.align.size()) {
	    endy = idPanel.alignPanel.seqPanel.align.size();
	}	
	
	//System.out.println("IdCanvas start/endy ypos " +  starty + " " + endy + " " + ypos);
	
	
	for (int i = starty; i < endy; i++) {
	    
	    if (idPanel.alignPanel.sel.contains(idPanel.alignPanel.seqPanel.align.ds[i])) {
		gg.setColor(Color.gray);
		gg.fillRect(0,da.getHeight(starty,i)+ ypos,size().width,da.ds[i].charHeight);
		gg.setColor(Color.white);
		
	    } else {
		gg.setColor(idPanel.alignPanel.seqPanel.align.ds[i].getColor());
		gg.fillRect(0,da.getHeight(starty,i)+ ypos,size().width,da.ds[i].charHeight);
		gg.setColor(Color.black);
	    }
	    
	    String string = idPanel.alignPanel.seqPanel.align.ds[i].getName() + "/" + 
		idPanel.alignPanel.seqPanel.align.ds[i].start + "-" + 
		idPanel.alignPanel.seqPanel.align.ds[i].end;
	    if (showScores) {
		gg.drawString(string,0,da.getHeight(starty,i)+ ypos+da.ds[i].charHeight/2-2);
	    } else {
		gg.drawString(string,0,da.getHeight(starty,i)+ ypos+da.ds[i].charHeight-2);
	    }
	}

	  if (rowstart == 0) {
	      ypos   = ypos +  idPanel.alignPanel.seqPanel.seqCanvas.chunkheight;
	  } else if (rowstart == 1) {

	      ypos   = ypos +  idPanel.alignPanel.seqPanel.seqCanvas.chunkheight;
	  } else {
	      ypos   = ypos +  idPanel.alignPanel.seqPanel.seqCanvas.chunkheight - rowstart*charHeight;
	  }

	

	
	starty = 0;
	
	int chunkwidth = idPanel.alignPanel.seqPanel.seqCanvas.chunkwidth;
	int startx = (int)(idPanel.alignPanel.seqPanel.offy/chunkwidth)*chunkwidth;
	int endx   = startx + chunkwidth;
	
	// Draw the middle panels while not truncated
	while (ypos <= size().height && endx < idPanel.alignPanel.seqPanel.align.maxLength) {
	    //System.out.println("IdPanel start/endy ypos " + starty + " " + endy + " " + ypos);
	    //System.out.println("IdCanvas start/endy ypos " +  starty + " " + endy + " " + ypos);
	    
	    for (int i = starty; i < endy; i++) {
		
		if (idPanel.alignPanel.sel.contains(idPanel.alignPanel.seqPanel.align.ds[i])) {
		    gg.setColor(Color.gray);
		    gg.fillRect(0,da.getHeight(starty,i)+ ypos,size().width,da.ds[i].charHeight);
		    gg.setColor(Color.white);
		    
		} else {
		    gg.setColor(idPanel.alignPanel.seqPanel.align.ds[i].getColor());
		    gg.fillRect(0,da.getHeight(starty,i)+ ypos,size().width,da.ds[i].charHeight);
		    gg.setColor(Color.black);
		}
		
		String string = idPanel.alignPanel.seqPanel.align.ds[i].getName() + "/" + 
		    idPanel.alignPanel.seqPanel.align.ds[i].start + "-" + 
		    idPanel.alignPanel.seqPanel.align.ds[i].end;
		if (showScores) {
		    gg.drawString(string,0,da.getHeight(starty,i)+ ypos+da.ds[i].charHeight/2-2);
		} else {
		    gg.drawString(string,0,da.getHeight(starty,i)+ ypos+da.ds[i].charHeight-2);
		}
	    }
	    
	    ypos   += idPanel.alignPanel.seqPanel.seqCanvas.chunkheight;
	    startx += chunkwidth;
	    endx = startx + chunkwidth;
	    
	    if (endx > idPanel.alignPanel.seqPanel.align.maxLength) {
		endx = idPanel.alignPanel.seqPanel.align.maxLength;
	    }
	    
	    starty = 0;
	    
	    if (endy > idPanel.alignPanel.seqPanel.align.size()) {
		endy = idPanel.alignPanel.seqPanel.align.size();
	    }
	    
	}
	
    } else {
				//Now draw the id strings
	for (int i = starty; i < endy; i++) {
	    
	    if (idPanel.alignPanel.sel.contains(idPanel.alignPanel.seqPanel.align.ds[i])) {
		gg.setColor(Color.gray);
		gg.fillRect(0,da.getHeight(starty,i),size().width,da.ds[i].charHeight);
		gg.setColor(Color.white);
		
	    } else {
		gg.setColor(idPanel.alignPanel.seqPanel.align.ds[i].getColor());
		gg.fillRect(0,da.getHeight(starty,i),size().width,da.ds[i].charHeight);
		gg.setColor(Color.black);
	    }
	    
	    String string = idPanel.alignPanel.seqPanel.align.ds[i].getName() + "/" + 
		idPanel.alignPanel.seqPanel.align.ds[i].start + "-" + 
		idPanel.alignPanel.seqPanel.align.ds[i].end;
	    if (showScores) {
		gg.drawString(string,0,da.getHeight(starty,i)+da.ds[i].charHeight/2-2);
	    } else {
		gg.drawString(string,0,da.getHeight(starty,i)+da.ds[i].charHeight-2);
	    }
	}
    }
    
    g.drawImage(img,0,0,this);    
  }
  public void update(Graphics g) {
    paint(g);
  }

  public int setCharHeight(FontMetrics fm, boolean showScores) {
   int height = fm.getHeight();
    if (idPanel.alignPanel.seqPanel.align instanceof DrawableAlignment) {
      da = (DrawableAlignment)idPanel.alignPanel.seqPanel.align;
      int i=0;
      while (i < da.ds.length && da.ds[i] != null) {
	if (da.ds[i] instanceof ScoreSequence) {
	  da.ds[i].charHeight = height*3;
	} else {
	  if (showScores) {
	    da.ds[i].charHeight = height*2;
	  } else {
	    da.ds[i].charHeight = height;
	  }
	}
	i++;
      }
    }
    if (showScores) {
      return fm.getHeight() * 2;
    } else {
      return fm.getHeight();
    }
  }
  public int getEndy() {
     int h=0;
     int i=starty;
     int tmp = starty;

     //     System.out.println("Starty = " + starty);
 //      while (h < idPanel.alignPanel.seqPanel.seqCanvas.size().height && i<da.ds.length && da.ds[i] != null) {
//         h += da.ds[i].charHeight;
//         i++;
//        }
//       //System.out.println("size " + i + " " + idPanel.alignPanel.seqPanel.align.size);
//       if (i >= idPanel.alignPanel.seqPanel.align.size) {
// 	i = idPanel.alignPanel.seqPanel.align.size-1;
// 	h = idPanel.alignPanel.seqPanel.seqCanvas.size().height;
// 	while (h > 0  && i >= 0) { 
// 	  h -= da.ds[i].charHeight;
// 	  i--;
// 	}
// 	//	i += 2;
// 	//tmp = starty - i +  seqPanel.align.size;
// 	tmp = i-1;
// 	i = idPanel.alignPanel.seqPanel.align.size;   
// 	//starty = i -  idPanel.alignPanel.seqPanel.align.size;
//         //i = idPanel.alignPanel.seqPanel.align.size;
//       } else {
//         i--;
//       }
//       starty = tmp;
//       //     System.out.println("Start " + i + " " + starty+  " " + (starty + idPanel.alignPanel.seqPanel.seqCanvas.size().height/charHeight));
//      return i;
     //    return (starty + idPanel.alignPanel.seqPanel.seqCanvas.size().height/charHeight);
     int out = idPanel.alignPanel.seqPanel.seqCanvas.getEndy();
     starty = idPanel.alignPanel.seqPanel.seqCanvas.starty;
     return out;
  }
  public Dimension minimumSize() {
    return new Dimension(100,100);
  }
  public Dimension preferredSize() {
    return minimumSize();
  }

  public int maxIdLength() {
    DrawableAlignment al = idPanel.alignPanel.seqPanel.align;
    int max = 0;
    int i = 0;
    while (i < al.ds.length && al.ds[i] != null) {
      if (al.ds[i].getName().length() > max) { 
	max = al.ds[i].getName().length();
      }
      i++;
    }
    return max;
  }
}















