package jalview;


import java.awt.*;


public class MatrixPanel extends Panel {

    int[][] mat;
    int rows;
    int cols;
    int min = 10000000000;
    int max = 0;
    public static      int GRADIENT = 0;
    public static int BLOCK    = 1;

    Image img;
    Graphics gg;

    int imgWidth;
    int imgHeight;
    int type;

    int[] probi;
    int[] probj;

    public MatrixPanel(int mat[][], int type,int[] probi, int[] probj) {
	this.mat = mat;
	this.type = type;
	this.probi = probi;
	this.probj = probj;

	rows = mat.length;
	cols = mat[0].length;

	System.out.println("Lengths are " + mat.length + " " + mat[0].length);

	for (int i = 0 ; i < mat.length; i++) {
	    for (int j = 0; j < mat[i].length; j++) {
 		if (min > mat[i][j]) {
		    min = mat[i][j];
		}
 		if (max <  mat[i][j]) {
		    max = mat[i][j];
		}
	    }
	}

    }

    public void paint(Graphics g) {
	if (img == null || imgWidth != size().width || imgHeight != size().height) {
	    imgWidth = size().width;
	    imgHeight = size().height;

	    img = createImage(imgWidth,imgHeight);

	    // The offscreen graphics
	    gg = img.getGraphics();
	    
	    for (int i = 0 ; i < rows; i++) {
		for (int j = 0; j < cols; j++) {
		    
		    int pos = (mat[i][j] - min)*255/(max-min+1);
		    
		    if (type == GRADIENT) {
			Color c = new Color(pos,0,0 );
			
			gg.setColor(c);
		} else {
		    if (mat[i][j] == 10) {
			gg.setColor(Color.red);
		    } else if (mat[i][j] == 20) {
			gg.setColor(Color.orange);
		    } else if (mat[i][j] == 30) {
			gg.setColor(Color.yellow);
		    } else if (mat[i][j] == 40) {
			gg.setColor(Color.green);
		    } else if (mat[i][j] == 50) {
			gg.setColor(Color.blue);
		    }
		}
			
		gg.drawLine(i,j,i,j);
		
		}
	    }
	    gg.setColor(Color.white);
	    for (int i = (rows+cols-1); i > 0; i--) {
		if (probi[i] > 0 && probj[i] > 0) {
		    //System.out.println("Probs " + i + " " + probi[i] + " " + probj[i]);
		    gg.drawLine(probi[i],probj[i],probi[i],probj[i]);
		}
	    }

	}

	g.drawImage(img,0,0,this);    
    }
}
