package jalview;

import java.awt.*;

public class ProgressBar extends Panel {

    public BarCanvas bc;
    public Label     l;
    public int       start;
    public int       end;
    public boolean   percent;

    public ProgressBar(int start, int end, boolean percent) {
	super();

	this.start   = start;
	this.end     = end;
	this.percent = percent;

	bc = new BarCanvas(start,end);
	l  = new Label(String.valueOf(bc.t) + "   ",Label.LEFT);

	setLayout(new BorderLayout());

	add("Center",bc);
	add("East"  ,l);
    }

    public void updateBar(int value) {
	bc.t = value;
	bc.paint(bc.getGraphics());

	//	System.out.println(start  + " " + end + " " + value);
	if (percent == true) {
	    l.setText(String.valueOf(value*100/(end - start + 1)) + "%");
	} else {
	    l.setText(String.valueOf(value));
	}
	l.validate();
    }

    public static void main(String[] args) {
	ProgressBar pb = new ProgressBar(1,1000,true);
	Frame f = new Frame("Test progress bar");
	f.setLayout(new BorderLayout());
	f.add("Center",pb);
	f.resize(200,100);
	f.show();

	int start = 0;
	try {
	    while (start < 1000) {
		start += 1;
		Thread.sleep(20);
		//		System.out.println("Updating bar " + start);
		pb.updateBar(start);
	    }
	} catch (Exception e) {
	    System.out.println(e);
	}
    }
}

class BarCanvas extends Canvas {
    int start;
    int end;

    int t;

    int xoffset = 20;
    int yoffset = 20;

    int width;
    int height;

    int percent;

    public BarCanvas(int start, int end) {
	super();
	
	this.start    = start;
	this.end      = end;
	this.t        = start;

    }

    public Dimension minimumSize() {
	return new Dimension(200,100);
    }

    public Dimension preferredSize() {
	return new Dimension(200,100);
    }

    public void paint(Graphics g) {
	Color c = g.getColor();
	
	xoffset = size().width/6;
	yoffset = size().height/6;
	
	height = (size().height - 2*yoffset);
	width  = (size().width  - 2*xoffset - 20);
	
	System.out.println("Size " + width  + " " + height);
	if (height < 0 ) { 
	    yoffset = 10;
	    height = size().height - 20;
	}
	
	if (width < 0 ) { 
	    xoffset = 10;
	    width = size().width - 40;
	}
	
	int s = t*width/(end - start + 1);
	
	//	g.setColor(Color.black);
	g.fill3DRect(xoffset,yoffset,width,height,false);
	
	g.setColor(Color.gray);
	g.fill3DRect(xoffset,yoffset,s, height,true);
	
	g.setColor(c);
	
    }
}
	
